#include "CFire.h"

CFire::CFire()
{
	power = 500;
}

CFire::~CFire()
{
}

CFire::Create()
{
	glPos = GLVECTOR(155,0,160);
	sizex = 20.0f;
	sizey = 70.0f;
	for(DWORD d=0;d<500;d++)
	{
		Objects[d].vPos.x = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.x;
		Objects[d].vPos.z = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.z;
		Objects[d].vPos.y = (float)(rand()%(int)(sizey*10))/10.0f+glPos.y;
		Objects[d].size = 2.0f;
	}
	for(d=0;d<500;d++)
	{
		Smoke[d].vPos.x = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.x;
		Smoke[d].vPos.z = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.z;
		Smoke[d].vPos.y = (float)(rand()%(int)(sizey*100))/10.0f+glPos.y;
		Smoke[d].size = 2.0f+(Smoke[d].vPos.y-glPos.y)*0.15f;
	}
}

void CFire::ActScene(DWORD time)
{
	for(DWORD d=0;d<500;d++)
	{
		Objects[d].vPos.y+=time/60.0f;
		if(rand()%6==0 || Objects[d].vPos.y>glPos.y+30.0f)
		{
			Objects[d].vPos.y = glPos.y;
			Objects[d].vPos.x = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.x;
			Objects[d].vPos.z = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.z;
		}
	}
	for(d=0;d<500;d++)
	{
		Smoke[d].vPos.y+=time/80.0f;
		Smoke[d].vPos.x+=(Smoke[d].vPos.x-glPos.x)*time/7000.0f;
		Smoke[d].vPos.z+=(Smoke[d].vPos.z-glPos.z)*time/7000.0f;
		Smoke[d].size+=0.15f;
		if(rand()%60==0 || Smoke[d].vPos.y>500.0f)
		{
			Smoke[d].size = 2.0f;
			Smoke[d].vPos.y = glPos.y;
			Smoke[d].vPos.x = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.x;
			Smoke[d].vPos.z = (float)(rand()%(int)(sizex*10))/10.0f-sizex*0.5f+glPos.z;
		}
	}
}

void CFire::Render(CAMERA View)
{
	float sx = (float)sin(-View.XDeg*PI/180.0f);
	float cx = (float)cos(-View.XDeg*PI/180.0f);
	float g[4] = {1.0f,1.0f,1.0f,1.0f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,tex);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
	glDepthMask(0);
	glBegin(GL_TRIANGLES);
	for(DWORD i=0;i<power;i++)
	{
		GLVECTOR nPos;
		nPos.x = cx*(Objects[i].vPos.x+View.vPos.x)-sx*(Objects[i].vPos.z-View.vPos.z);
		nPos.y = Objects[i].vPos.y;
		nPos.z = sx*(Objects[i].vPos.x+View.vPos.x)+cx*(Objects[i].vPos.z-View.vPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(1,0);
		glVertex3f(+Objects[i].size+nPos.x,nPos.y,nPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(0.5f,1);
		glVertex3f(nPos.x,nPos.y+Objects[i].size*4.0f,nPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(0,0);
		glVertex3f(-Objects[i].size+nPos.x,nPos.y,nPos.z);
	}
	glEnd();
	glBindTexture(GL_TEXTURE_2D,texsmoke);
	float h[4] = {0.0f,0.0f,0.0f,1.0f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,h);
	glBegin(GL_QUADS);
	for(i=0;i<500;i++)
	{
		GLVECTOR nPos;
		nPos.x = cx*(Smoke[i].vPos.x+View.vPos.x)-sx*(Smoke[i].vPos.z-View.vPos.z);
		nPos.y = Smoke[i].vPos.y;
		nPos.z = sx*(Smoke[i].vPos.x+View.vPos.x)+cx*(Smoke[i].vPos.z-View.vPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(0,1);
		glVertex3f(+Smoke[i].size+nPos.x,nPos.y+Smoke[i].size*3.0f,nPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(1,1);
		glVertex3f(-Smoke[i].size+nPos.x,nPos.y+Smoke[i].size*3.0f,nPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(1,0);
		glVertex3f(-Smoke[i].size+nPos.x,nPos.y,nPos.z);
		glNormal3f(0,0,-1);
		glTexCoord2f(0,0);
		glVertex3f(+Smoke[i].size+nPos.x,nPos.y,nPos.z);
	}
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDepthMask(1);
}