#include "CRain.h"

CRain::CRain()
{
	power=0.0f;
	AktVtx=0;
	tex1=tex2=0;
}

CRain::~CRain()
{
	if(AktVtx)
	{
		delete vtx;
		vtx=NULL;
	}
}

void CRain::StartRain(void)
{
	AktVtx = 2000;
	vtx = new GLVERTEX[AktVtx*4];
	float size = 1.5;
	GLVECTOR vNorm = GLVECTOR(0,0,-1);
	for(DWORD d=0;d<AktVtx*4;d+=4)
	{
		GLVECTOR vPos;
		vPos.z = (float)(rand()%80)+1;
		vPos.x = (float)(rand()%((int)(vPos.z*1.5f)))-(vPos.z*1.5f)/2.0f;
		vPos.z -=1;
		vPos.y = (float)(rand()%80);
		vtx[d] = GLVERTEX(GLVECTOR(vPos.x+size,vPos.y,vPos.z),vNorm,0,1);
		vtx[d+1] = GLVERTEX(GLVECTOR(vPos.x-size,vPos.y,vPos.z),vNorm,1,1);
		vtx[d+2] = GLVERTEX(GLVECTOR(vPos.x-size,vPos.y-4.0f*size,vPos.z),vNorm,1,0);
		vtx[d+3] = GLVERTEX(GLVECTOR(vPos.x+size,vPos.y-4.0f*size,vPos.z),vNorm,0,0);
	}
}

void CRain::ActRain(DWORD time)
{
	for(DWORD d=0;d<AktVtx*4;d+=4)
	{
		vtx[d].y -= 2.0f;
		vtx[d+1].y -= 2.0f;
		vtx[d+2].y -= 2.0f;
		vtx[d+3].y -= 2.0f;
		if(vtx[d].y<1.0f)
		{
			vtx[d].y += 80;
			vtx[d+1].y += 80.0f;
			vtx[d+2].y += 80.0f;
			vtx[d+3].y += 80.0f;
		}
	}
}

void CRain::Render()
{
	float g[4] = {1.0f,1.0f,1.0f,1.0f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glEnable(GL_TEXTURE_2D);
	if(power<200) glBindTexture(GL_TEXTURE_2D,tex1);
	else glBindTexture(GL_TEXTURE_2D,tex2);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
	glDepthMask(0);
	glBegin(GL_QUADS);
	for(DWORD d=0;d<power*32;d++)
	{
		glTexCoord2f(vtx[d].tu,vtx[d].tv);
		glNormal3f(vtx[d].nx,vtx[d].ny,vtx[d].nz);
		glVertex3f(vtx[d].x,vtx[d].y,vtx[d].z);
	}
	glEnd();
	glDisable(GL_BLEND);
	glDepthMask(1);
}