#include "CSkyBox.h"

CSkyBox::CSkyBox()
{
	tex1=tex2=0;
	alpha=1.0f;
	light=0;
}

CSkyBox::~CSkyBox()
{
}

void CSkyBox::CreateSkybox(void)
{
	float size=1002;
	vtx[0] = GLVERTEX(GLVECTOR(-size/2.0f,size*0.9,size/2.0f),GLVECTOR(0,0,0),0,0);
	vtx[1] = GLVERTEX(GLVECTOR(size/2.0f,size*0.9f,size/2.0f),GLVECTOR(0,0,0),1,0);
	vtx[2] = GLVERTEX(GLVECTOR(size/2.0f,-size*0.1f,size/2.0f),GLVECTOR(0,0,0),1,1);
	vtx[3] = GLVERTEX(GLVECTOR(-size/2.0f,-size*0.1f,size/2.0f),GLVECTOR(0,0,0),1,0);

	vtx[4] = GLVERTEX(GLVECTOR(size/2.0f,size*0.9f,size/2.0f),GLVECTOR(0,0,0),0,0);
	vtx[5] = GLVERTEX(GLVECTOR(size/2.0f,size*0.9f,-size/2.0f),GLVECTOR(0,0,0),1,0);
	vtx[6] = GLVERTEX(GLVECTOR(size/2.0f,-size*0.1f,-size/2.0f),GLVECTOR(0,0,0),1,1);
	vtx[7] = GLVERTEX(GLVECTOR(size/2.0f,-size*0.1f,size/2.0f),GLVECTOR(0,0,0),1,0);

	vtx[8] = GLVERTEX(GLVECTOR(size/2.0f,size*0.9f,-size/2.0f),GLVECTOR(0,0,0),0,0);
	vtx[9] = GLVERTEX(GLVECTOR(-size/2.0f,size*0.9f,-size/2.0f),GLVECTOR(0,0,0),1,0);
	vtx[10] = GLVERTEX(GLVECTOR(-size/2.0f,-size*0.1f,-size/2.0f),GLVECTOR(0,0,0),1,1);
	vtx[11] = GLVERTEX(GLVECTOR(size/2.0f,-size*0.1f,-size/2.0f),GLVECTOR(0,0,0),0,1);

	vtx[12] = GLVERTEX(GLVECTOR(-size/2.0f,size*0.9f,-size/2.0f),GLVECTOR(0,0,0),0,0);
	vtx[13] = GLVERTEX(GLVECTOR(-size/2.0f,size*0.9f,size/2.0f),GLVECTOR(0,0,0),1,0);
	vtx[14] = GLVERTEX(GLVECTOR(-size/2.0f,-size*0.1f,size/2.0f),GLVECTOR(0,0,0),1,1);
	vtx[15] = GLVERTEX(GLVECTOR(-size/2.0f,-size*0.1f,-size/2.0f),GLVECTOR(0,0,0),0,1);

	vtx[16] = GLVERTEX(GLVECTOR(size/2.0f,size*0.9f,size/2.0f),GLVECTOR(0,0,0),0,0);
	vtx[17] = GLVERTEX(GLVECTOR(-size/2.0f,size*0.9f,size/2.0f),GLVECTOR(0,0,0),1,0);
	vtx[18] = GLVERTEX(GLVECTOR(-size/2.0f,size*0.9f,-size/2.0f),GLVECTOR(0,0,0),1,1);
	vtx[19] = GLVERTEX(GLVECTOR(size/2.0f,size*0.9f,-size/2.0f),GLVECTOR(0,0,0),0,1);
}

void CSkyBox::Render()
{
	float g[4] = {1.0f,1.0f,1.0f,alpha};
	float l[4] = {5.0f,5.0f,5.0f,alpha};
	if(light) glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,l);
	else glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glEnable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
	glDepthMask(0);
	glBindTexture(GL_TEXTURE_2D,tex1);
	glBegin(GL_QUADS);
	for(WORD d=0;d<20;d++)
	{
		glNormal3f(vtx[d].nx,vtx[d].ny,-vtx[d].nz);
		glTexCoord2f(vtx[d].tu,vtx[d].tv);
		glVertex3f(vtx[d].x,vtx[d].y,-vtx[d].z);
	}
	glEnd();
	float h[4] = {1.0f,1.0f,1.0f,1.0f-alpha};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,h);
	glBindTexture(GL_TEXTURE_2D,tex2);
	glBegin(GL_QUADS);
	for(d=0;d<20;d++)
	{
		glNormal3f(vtx[d].nx,vtx[d].ny,-vtx[d].nz);
		glTexCoord2f(vtx[d].tu,vtx[d].tv);
		glVertex3f(vtx[d].x,vtx[d].y,-vtx[d].z);
	}
	glEnd();
	glDepthMask(1);
	glDisable(GL_BLEND);
}
