#include "CTree.h"

CTree::CTree()
{
	AktObj = 0;
}

CTree::~CTree()
{
}

void CTree::CreateTrees(DWORD ScpSize,GLVERTEX *Terrainvtx)
{
	AktObj = 3000;
	Objects = new OBJECT[AktObj];
	ZeroMemory(Objects,sizeof(Objects));
	float size = 5.0f;
	for(DWORD dw=0;dw<AktObj;dw++)
	{
		size = (float)(rand()%50)/10.0f;
		while(size<2.0f)
		{
			size = (float)(rand()%50)/10.0f;
		}
		GLVECTOR vPos;
		vPos.x = (float)(rand()%10000)/10.0f-500.0f;
		vPos.y = 500;
		vPos.z = (float)(rand()%10000)/10.0f-500.0f;
		Objects[dw].size = size;

		//Quads
		Objects[dw].main[0] = GLVERTEX(GLVECTOR(-size,size*3.7f,0),GLVECTOR(0,0,-1),0,1);
		Objects[dw].main[1] = GLVERTEX(GLVECTOR(+size,size*3.7f,0),GLVECTOR(0,0,-1),1,1);
		Objects[dw].main[2] = GLVERTEX(GLVECTOR(+size,size*1.35f,0),GLVECTOR(0,0,-1),1,0);
		Objects[dw].main[3] = GLVERTEX(GLVECTOR(-size,size*1.35f,0),GLVECTOR(0,0,-1),0,0);
		Objects[dw].main[4] = GLVERTEX(GLVECTOR(-size*0.5f,size*3.7f,-size*0.87f),GLVECTOR(0,0,-1),0,1);
		Objects[dw].main[5] = GLVERTEX(GLVECTOR(+size*0.5f,size*3.7f,+size*0.87f),GLVECTOR(0,0,-1),1,1);
		Objects[dw].main[6] = GLVERTEX(GLVECTOR(+size*0.5f,size*1.35f,+size*0.87f),GLVECTOR(0,0,-1),1,0);
		Objects[dw].main[7] = GLVERTEX(GLVECTOR(-size*0.5f,size*1.35f,-size*0.87f),GLVECTOR(0,0,-1),0,0);
		Objects[dw].main[8] = GLVERTEX(GLVECTOR(+size*0.5f,size*3.7f,-size*0.87f),GLVECTOR(0,0,-1),0,1);
		Objects[dw].main[9] = GLVERTEX(GLVECTOR(-size*0.5f,size*3.7f,+size*0.87f),GLVECTOR(0,0,-1),1,1);
		Objects[dw].main[10] = GLVERTEX(GLVECTOR(-size*0.5f,size*1.35f,+size*0.87f),GLVECTOR(0,0,-1),1,0);
		Objects[dw].main[11] = GLVERTEX(GLVECTOR(+size*0.5f,size*1.35f,-size*0.87f),GLVECTOR(0,0,-1),0,0);
		
		//Branches
		for(DWORD d=0;d<15;d++)
		{
			float h = (rand()%(int)((3.8f-1.5f-1.35f)*size*100))/100.0f+1.35f*size;
			int angle = rand()%360;
			float sx = sin((float)angle*PI/180.0f);
			float cx = cos((float)angle*PI/180.0f);
			float sy=(float)sin(60.0f*PI/180.0f);
			float cy=(float)cos(60.0f*PI/180.0f);
			Objects[dw].branches[d*3] = GLVERTEX(GLVECTOR(0,0,0),GLVECTOR(0,1,0),0.5f,0);
			Objects[dw].branches[d*3+1] = GLVERTEX(GLVECTOR(-size*0.75f,0,size*1.5f),GLVECTOR(0,1,0),0,1);
			Objects[dw].branches[d*3+2] = GLVERTEX(GLVECTOR(size*0.75f,0,size*1.5f),GLVECTOR(0,1,0),1,1);
			for(BYTE b=1;b<3;b++)
			{
				float newx = Objects[dw].branches[d*3+b].x;
				float newy = Objects[dw].branches[d*3+b].y*cy+Objects[dw].branches[d*3+b].z*sy;
				float newz = -Objects[dw].branches[d*3+b].y*sy+Objects[dw].branches[d*3+b].z*cy;
				Objects[dw].branches[d*3+b].x = newx*cx-newz*sx;
				Objects[dw].branches[d*3+b].y = newy;
				Objects[dw].branches[d*3+b].z = newx*sx+newz*cx;
				newx = Objects[dw].branches[d*3+b].nx;
				newy = Objects[dw].branches[d*3+b].ny*cy+Objects[dw].branches[d*3+b].nz*sy;
				newz = -Objects[dw].branches[d*3+b].ny*sy+Objects[dw].branches[d*3+b].nz*cy;
				Objects[dw].branches[d*3+b].nx = newx*cx-newz*sx;
				Objects[dw].branches[d*3+b].ny = newy;
				Objects[dw].branches[d*3+b].nz = newx*sx+newz*cx;
			}
			Objects[dw].branches[d*3].y+=h;
			Objects[dw].branches[d*3+1].y+=h;
			Objects[dw].branches[d*3+2].y+=h;
		}

		//Trunk
		Objects[dw].trunk[0] = GLVERTEX(GLVECTOR(0,size*3.5,0),GLVECTOR(0,1,0),0,0);
		Objects[dw].trunk[1] = GLVERTEX(GLVECTOR(-size*0.1f,0,0),GLVECTOR(-1,0,0),0,5);
		Objects[dw].trunk[2] = GLVERTEX(GLVECTOR(-size*0.1f*0.5f,0,+size*0.1f*0.87f),GLVECTOR(-0.5f,0,0.87f),0.33,5);
		Objects[dw].trunk[3] = GLVERTEX(GLVECTOR(+size*0.1f*0.5f,0,+size*0.1f*0.87f),GLVECTOR(+0.5f,0,0.87f),0.66,5);
		Objects[dw].trunk[4] = GLVERTEX(GLVECTOR(+size*0.1f,0,0),GLVECTOR(1,0,0),1,5);
		Objects[dw].trunk[5] = GLVERTEX(GLVECTOR(+size*0.1f*0.5f,0,-size*0.1f*0.87f),GLVECTOR(+0.5f,0,-0.87f),1.33,5);
		Objects[dw].trunk[6] = GLVERTEX(GLVECTOR(-size*0.1f*0.5f,0,-size*0.1f*0.87f),GLVECTOR(-0.5f,0,-0.87f),1.66,5);
		Objects[dw].trunk[7] = GLVERTEX(GLVECTOR(-size*0.1f,0,0),GLVECTOR(-1,0,0),2,5);

SETPOS:
		for(DWORD dz=0;dz<ScpSize-1;dz++)
		{
			for(DWORD dx=0;dx<ScpSize-1;dx++)
			{
				if(Terrainvtx[dz*ScpSize+dx].x<=vPos.x &&
				   Terrainvtx[dz*ScpSize+dx].z<=vPos.z &&
				   Terrainvtx[(dz+1)*ScpSize+(dx+1)].x>vPos.x &&
				   Terrainvtx[(dz+1)*ScpSize+(dx+1)].z>vPos.z)
				{
					float t,u,v;
					if(IntersectTriangle(vPos,GLVECTOR(0,1,0),GLVECTOR(Terrainvtx[dz*ScpSize+dx].x,Terrainvtx[dz*ScpSize+dx].y,Terrainvtx[dz*ScpSize+dx].z),GLVECTOR(Terrainvtx[dz*ScpSize+dx+1].x,Terrainvtx[dz*ScpSize+dx+1].y,Terrainvtx[dz*ScpSize+dx+1].z),GLVECTOR(Terrainvtx[(dz+1)*ScpSize+dx+1].x,Terrainvtx[(dz+1)*ScpSize+dx+1].y,Terrainvtx[(dz+1)*ScpSize+dx+1].z),&t,&u,&v)==0)
						IntersectTriangle(vPos,GLVECTOR(0,1,0),GLVECTOR(Terrainvtx[dz*ScpSize+dx].x,Terrainvtx[dz*ScpSize+dx].y,Terrainvtx[dz*ScpSize+dx].z),GLVECTOR(Terrainvtx[(dz+1)*ScpSize+dx+1].x,Terrainvtx[(dz+1)*ScpSize+dx+1].y,Terrainvtx[(dz+1)*ScpSize+dx+1].z),GLVECTOR(Terrainvtx[(dz+1)*ScpSize+dx].x,Terrainvtx[(dz+1)*ScpSize+dx].y,Terrainvtx[(dz+1)*ScpSize+dx].z),&t,&u,&v);
					vPos.y += t-1; 
					if(vPos.y<0.0f)
					{
						vPos.x = (float)(rand()%1000)-500.0f;
						vPos.z = (float)(rand()%1000)-500.0f;
						vPos.y = 500;
						goto SETPOS;
					}
				}
			}
		}
		MoveObjects(dw,vPos);
		Objects[dw].vPos = vPos;
	}
}

CTree::MoveObjects(DWORD w,GLVECTOR move)
{
	for(DWORD d=0;d<12;d++)
	{
		Objects[w].main[d].x+=move.x;
		Objects[w].main[d].y+=move.y;
		Objects[w].main[d].z+=move.z;
	}
	for(d=0;d<45;d++)
	{
		Objects[w].branches[d].x+=move.x;
		Objects[w].branches[d].y+=move.y;
		Objects[w].branches[d].z+=move.z;
	}
	for(d=0;d<8;d++)
	{
		Objects[w].trunk[d].x+=move.x;
		Objects[w].trunk[d].y+=move.y;
		Objects[w].trunk[d].z+=move.z;
	}
}

CTree::RenderSprites(CAMERA View)
{
	float sx = (float)sin(-View.XDeg*PI/180.0f);
	float cx = (float)cos(-View.XDeg*PI/180.0f);
	float g[4] = {255.0f/255.0f,255.0f/255.0f,255.0f/255.0f,1.0f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_LESS,0.5);
	glBindTexture(GL_TEXTURE_2D,tex1);
	glBegin(GL_QUADS);
	for(DWORD i=0;i<AktObj;i++)
	{
		Objects[i].distance = (-View.vPos.x-Objects[i].vPos.x)*(-View.vPos.x-Objects[i].vPos.x)+(View.vPos.z-Objects[i].vPos.z)*(View.vPos.z-Objects[i].vPos.z);
		if(Objects[i].distance>5000.0f)
		{
			GLVECTOR nPos;
			nPos.x = cx*(Objects[i].vPos.x+View.vPos.x)-sx*(Objects[i].vPos.z-View.vPos.z);
			nPos.y = Objects[i].vPos.y;
			nPos.z = sx*(Objects[i].vPos.x+View.vPos.x)+cx*(Objects[i].vPos.z-View.vPos.z);
			if(nPos.z>0)
			{
			glNormal3f(0,0,-1);
			glTexCoord2f(0,0);
			glVertex3f(-Objects[i].size+nPos.x,nPos.y,nPos.z);
			glNormal3f(0,0,-1);
			glTexCoord2f(1,0);
			glVertex3f(+Objects[i].size+nPos.x,nPos.y,nPos.z);
			glNormal3f(0,0,-1);
			glTexCoord2f(1,1);
			glVertex3f(+Objects[i].size+nPos.x,nPos.y+Objects[i].size*4.0f,nPos.z);
			glNormal3f(0,0,-1);
			glTexCoord2f(0,1);
			glVertex3f(-Objects[i].size+nPos.x,nPos.y+Objects[i].size*4.0f,nPos.z);
			}
		}
	}
	glEnd();
	glDisable(GL_ALPHA_TEST);
}

CTree::Render()
{
	float g[4] = {255.0f/255.0f,255.0f/255.0f,255.0f/255.0f,1.0f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_LESS,0.5);
	glDisable(GL_CULL_FACE);
	glBindTexture(GL_TEXTURE_2D,tex3);
	glBegin(GL_QUADS);
	for(DWORD i=0;i<AktObj;i++)
	{
		if(Objects[i].distance<=5000.0f)
		{
			for(DWORD d=0;d<12;d++)
			{	
				glNormal3f(Objects[i].main[d].nx,Objects[i].main[d].ny,Objects[i].main[d].nz);
				glTexCoord2f(Objects[i].main[d].tu,Objects[i].main[d].tv);
				glVertex3f(Objects[i].main[d].x,Objects[i].main[d].y,Objects[i].main[d].z);
			}
		}
	}
	glEnd();
	glBindTexture(GL_TEXTURE_2D,tex5);
	glBegin(GL_TRIANGLES);
	for(i=0;i<AktObj;i++)
	{
		if(Objects[i].distance<=5000.0f)
		{
			for(DWORD d=0;d<45;d++)
			{	
				glNormal3f(Objects[i].branches[d].nx,Objects[i].branches[d].ny,Objects[i].branches[d].nz);
				glTexCoord2f(Objects[i].branches[d].tu,Objects[i].branches[d].tv);
				glVertex3f(Objects[i].branches[d].x,Objects[i].branches[d].y,Objects[i].branches[d].z);
			}
		}
	}
	glEnd();
	glDisable(GL_ALPHA_TEST);
	glBindTexture(GL_TEXTURE_2D,textrunk);
	for(i=0;i<AktObj;i++)
	{
		if(Objects[i].distance<=5000.0f)
		{
			glBegin(GL_TRIANGLE_FAN);
			for(DWORD d=0;d<8;d++)
			{	
				glNormal3f(Objects[i].trunk[d].nx,Objects[i].trunk[d].ny,Objects[i].trunk[d].nz);
				glTexCoord2f(Objects[i].trunk[d].tu,Objects[i].trunk[d].tv);
				glVertex3f(Objects[i].trunk[d].x,Objects[i].trunk[d].y,Objects[i].trunk[d].z);
			}
			glEnd();
		}
	}
	glDisable(GL_ALPHA_TEST);
	glEnable(GL_CULL_FACE);
}