#include "CWater.h"

CWater::CWater()
{
	AktVtx=0;
	AktQuad=0;
	Akttime = 0;
}

CWater::~CWater()
{
	if(AktVtx)
	{
		delete vtx;
		vtx=NULL;
	}
	if(AktQuad)
	{
		delete Quads;
		Quads=NULL;
	}
}

void CWater::ActScene(DWORD time,CAMERA View)
{
	float sx = (float)sin(View.XDeg*PI/180.0f);
	float cx = (float)cos(View.XDeg*PI/180.0f);
	float sy = (float)sin(View.YDeg*PI/180.0f);
	float cy = (float)cos(View.YDeg*PI/180.0f);
	Akttime+=time;
	GLVECTOR glVec,glVec2;
	GLVECTOR glC;
	glC.x = -405;
	glC.z = -490;
	for(DWORD d=0;d<AktVtx;d++)
	{
		glVec2.x = cx*vtx[d].x-sx*vtx[d].z;
		glVec2.y = vtx[d].y;
		glVec2.z = sx*vtx[d].x+cx*vtx[d].z;
		glVec.x = glVec2.x-View.vPos.x;
		glVec.y = glVec2.y;
		glVec.z = glVec2.z+View.vPos.z;
		vtx[d].y = ((float)sin(sqrt((glVec.x-glC.x)*(glVec.x-glC.x)+(glVec.z-glC.z)*(glVec.z-glC.z))-Akttime/100.0f)
			+(float)sin(sqrt((glVec.x-glC.x+25)*(glVec.x-glC.x+25)+(glVec.z-glC.z)*(glVec.z-glC.z))-Akttime/100.0f)
			+(float)sin(sqrt((glVec.x-glC.x-25)*(glVec.x-glC.x-25)+(glVec.z-glC.z)*(glVec.z-glC.z))-Akttime/100.0f))/5.0f;
		vtx[d].ny = ((float)cos(sqrt((glVec.x-glC.x)*(glVec.x-glC.x)+(glVec.z-glC.z)*(glVec.z-glC.z))-Akttime/100.0f)
			+(float)cos(sqrt((glVec.x-glC.x+25)*(glVec.x-glC.x+25)+(glVec.z-glC.z)*(glVec.z-glC.z))-Akttime/100.0f)
			+(float)cos(sqrt((glVec.x-glC.x-25)*(glVec.x-glC.x-25)+(glVec.z-glC.z)*(glVec.z-glC.z))-Akttime/100.0f))/4.0f;
	}
}

void CWater::CreateSurface()
{
	GLVECTOR v0 = GLVECTOR(0,0,0);
	GLVECTOR v1 = GLVECTOR(-100,0,100);
	GLVECTOR v2 = GLVECTOR(100,0,100);
	DWORD TilesX = 100;
	DWORD TilesZ = 100;
	AktVtx = 1+(TilesX+1)*TilesZ;
	vtx = new GLVERTEX[AktVtx*100];
	AktQuad = (TilesX+1)*(TilesZ+1)*4;
	Quads = new DWORD[AktQuad];
	GLVECTOR vNorm = GLVECTOR(0,1,0);
	vtx[0] = GLVERTEX(v0,vNorm,0,0);
	for(DWORD z=1;z<=TilesZ;z++)
	{
		for(DWORD x=0;x<=TilesX;x++)
		{
			vtx[1+z*(TilesX+1)+x] = GLVERTEX(GLVECTOR((x-50.0f)*pow(2,(float)z/7.0f)/25.0f,0,2.0f+pow(2,(float)z/7.0f)),vNorm,0,0);
		}
	}
	DWORD cquad=0;
	for(z=0;z<TilesZ-1;z++)
	{
		for(DWORD x=0;x<TilesX;x++)
		{
			Quads[cquad++]=1+z*(TilesX+1)+x+1;
			Quads[cquad++]=1+(z+1)*(TilesX+1)+x+1;
			Quads[cquad++]=1+(z+1)*(TilesX+1)+x;
			Quads[cquad++]=1+z*(TilesX+1)+x;
		}
	}
	AktQuad = cquad;
}

void CWater::Render()
{
//	glPolygonMode(GL_FRONT,GL_LINE);
	float g[4] = {0.0f/255.0f,117.0f/255.0f,200.0f/255.0f,0.55f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glEnable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
	glBegin(GL_QUADS);
	for(DWORD d=0;d<AktQuad;d++)
	{	
		glNormal3f(vtx[Quads[d]].nx,vtx[Quads[d]].ny,vtx[Quads[d]].nz);
		glTexCoord2f(vtx[Quads[d]].tu,vtx[Quads[d]].tv);
		glVertex3f(vtx[Quads[d]].x,vtx[Quads[d]].y,vtx[Quads[d]].z);
	}
	glEnd();
//	glPolygonMode(GL_FRONT,GL_FILL);
	glDisable(GL_BLEND);
}