#include "Demo.h"

int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG				msg;
	WNDCLASS		wc;
	hInstance		= GetModuleHandle(NULL);
	wc.style		= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc	= (WNDPROC) WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(NULL,IDI_WINLOGO);
	wc.hCursor		= LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground= NULL;
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= "OpenGL";
	RegisterClass(&wc);
	if(!OpenGL.InitOpenGLFullscreen(hInstance,&hWndMain,&wc,"OpenGL","OpenGL-Demo",1024,768,32)) exit(0);
	InitDirectInput(hInstance,hWndMain,DIRECTINPUT_VERSION,1,1);
	ZeroMemory(&ViewDat,sizeof(ViewDat));
	ViewDat.vPos.x = 380.0f;
	ViewDat.vPos.y = 8.0f;
	ViewDat.vPos.z = -400.0f;
	ViewDat.XDeg = -200;
	ViewDat.cNear = 2.0f;
	ViewDat.cFar = 1300.0f;
	OpenGL.SetProjection(1.3333f,60.0f,ViewDat.cNear,ViewDat.cFar);
	OpenGL.CreateTexture(&texIntro,"INTRO.BMP",3,GL_RGB,1,0);

	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glBindTexture(GL_TEXTURE_2D,texIntro);
	glLoadIdentity();
	glDisable(GL_CULL_FACE);
	glRotatef(180.0f,0.0f,1.0f,0.0f);
	float g[4] = {1.0f,1.0f,1.0f,1.0f};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,g);
	glBegin(GL_QUADS);
	glTexCoord2f(1,0);
	glVertex3f(-40.0f,-30.0f,50);
	glTexCoord2f(0,0);
	glVertex3f(40.0f,-30.0f,50);
	glTexCoord2f(0,1);
	glVertex3f(40.0f,+30.0f,50);
	glTexCoord2f(1,1);
	glVertex3f(-40.0f,+30.0f,50);
	glEnd();
	SwapBuffers(OpenGL.hDC);
	glEnable(GL_CULL_FACE);

	ObjTerrain.LoadTerrainBMP("TERRAIN.BMP",1002,2.0f);
	OpenGL.CreateTexture(&ObjTree.textrunk,"TREE1_1.BMP",3,GL_RGB,1,0);
	OpenGL.CreateTextureAlpha(&ObjTree.tex1,"TREE1S.BMP","TREE1SC.BMP",1,0);
	OpenGL.CreateTextureAlpha(&ObjTree.tex3,"TREE1_3.BMP","TREE1_3C.BMP",1,0);
	OpenGL.CreateTextureAlpha(&ObjTree.tex5,"TREE1_5.BMP","TREE1_5C.BMP",1,0);

	ObjTree.CreateTrees(ObjTerrain.ScpSize,ObjTerrain.vtx);
	ObjWater.CreateSurface();
	ObjSkyBox.CreateSkybox();
	OpenGL.CreateTexture(&ObjSkyBox.tex1,"SKYBOX1.BMP",3,GL_RGB,1,0);
	OpenGL.CreateTexture(&ObjSkyBox.tex2,"SKYBOX2.BMP",3,GL_RGB,1,0);
	OpenGL.CreateTexture(&ObjTerrain.texsand,"SAND.BMP",3,GL_RGB,1,0);
	OpenGL.CreateTexture(&ObjWaterfall.texwater,"WATERFALL.BMP",3,GL_RGB,1,0);
	OpenGL.CreateTextureAlpha(&ObjWaterfall.texcloud,"P0.BMP","P0CKEY2.BMP",1,0);
	OpenGL.CreateTextureAlpha(&ObjRain.tex1,"RAIN2.BMP","RAINCKEY.BMP",1,0);
	OpenGL.CreateTextureAlpha(&ObjRain.tex2,"RAIN2.BMP","RAINCKEY2.BMP",1,0);
	OpenGL.CreateTextureAlpha(&ObjFire.tex,"FEUER.BMP","FEUERC.BMP",1,0);
	OpenGL.CreateTextureAlpha(&ObjFire.texsmoke,"P0.BMP","P0CKEY.BMP",1,0);
	ObjRain.StartRain();
	ObjWaterfall.Create();
	ObjFire.Create();
	glEnable(GL_FOG);
	glFogf(GL_FOG_END,1000);
    while(1)
    {
		if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
		{
			if(!GetMessage(&msg,NULL,0,0)) return msg.wParam;
			TranslateMessage(&msg); 
			DispatchMessage(&msg);
	    }
		
		else Loop(hWndMain);
    }
    return 0;
} 

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
    switch(uMsg)
    {
		case WM_PAINT:
			if(OpenGL.hRC) SwapBuffers(OpenGL.hDC);
			break;
		case WM_DESTROY:
			if(OpenGL.hRC)
			{
				CloseDirectInput();
				OpenGL.ShutDown();
			}
			PostQuitMessage(0);
            break;
    }
    return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

void Loop(HWND hWnd)
{
	bool ShtDwn=0;
	DIDEVICEOBJECTDATA		DIDObjectData[16];
	DWORD					dwElements,hr;
	dwElements = 16;
	char name[10];
	hr = lpDIDKeyboard->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),DIDObjectData,&dwElements,0); //Tastaturabfrage
	if(hr==DIERR_INPUTLOST) lpDIDKeyboard->Acquire();
	for(DWORD el=0;el<dwElements;el++)
	{
		switch(DIDObjectData[el].dwOfs)
		{
			case DIK_ESCAPE:
				if(DIDObjectData[el].dwData&0x80) ShtDwn=1;
				break;
			case DIK_UP:
				if(bInter && DIDObjectData[el].dwData&0x80) KUp=1;
				else KUp=0;
				break;
			case DIK_DOWN:
				if(bInter && DIDObjectData[el].dwData&0x80) KDown=1;
				else KDown=0;
				break;
			case DIK_LEFT:
				if(bInter && DIDObjectData[el].dwData&0x80) KLeft=1;
				else KLeft=0;
				break;
			case DIK_RIGHT:
				if(bInter && DIDObjectData[el].dwData&0x80) KRight=1;
				else KRight=0;
				break;
			case DIK_I:
				bInter=1;
				break;
			case DIK_S:
				if(DIDObjectData[el].dwData&0x80)
				{
					itoa(AktShot,name,10);
					strcat(name,".BMP");
					OpenGL.Screenshot(name);
					AktShot++;
				}
				break;
		}
	}
	dwElements = 16;
	hr = lpDIDMouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),DIDObjectData,&dwElements,0);	//Mausabfrage
	if(hr==DIERR_INPUTLOST) lpDIDMouse->Acquire();
	if(bInter) for(el=0;el<dwElements;el++)
	{
		switch(DIDObjectData[el].dwOfs)
		{
			case DIMOFS_X:
				ViewDat.XDeg+=(float((signed)DIDObjectData[el].dwData))/10.0f;
				if(ViewDat.XDeg>=360.0f) ViewDat.XDeg-=360.0f;
				else if(ViewDat.XDeg<0.0f) ViewDat.XDeg=360.0f-ViewDat.XDeg;
				break;
			case DIMOFS_Y:
				ViewDat.YDeg+=(float((signed)DIDObjectData[el].dwData))/10.0f;
				if(ViewDat.YDeg<=-90.0f) ViewDat.YDeg = -89.99f;
				else if(ViewDat.YDeg>=90.0f) ViewDat.YDeg = 89.99f;
				break;
			case DIMOFS_BUTTON0:
				ViewDat.vPos.y+=2.5f;
				break;
			case DIMOFS_BUTTON1:
				ViewDat.vPos.y-=2.5f;
				break;
		}
	}
	if(timeGetTime()>FPSTime+1000)
	{
		FPS=ActFrame;
		ActFrame=0;
		FPSTime=timeGetTime();
	}
	DWORD t = timeGetTime();
	if(ActTime==0) ActTime = t;
	if(t-ActTime>=40) ActScene((t-ActTime));
	ActTime=t;
	Render();
	if(ShtDwn) SendMessage(hWndMain,WM_CLOSE,0,0);
}

bool Render()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glEnable(GL_LIGHTING);
	glFogf(GL_FOG_DENSITY,ObjRain.power/5000.0f);
	float c[4] = {0.0f,0.35f,0.5f,0.0f};
	glFogfv(GL_FOG_COLOR,c);

	glLoadIdentity();
	glRotatef(ViewDat.YDeg,1.0f,0.0f,0.0f);
	glRotatef(180.0f,0.0f,1.0f,0.0f);
	glTranslatef(0,-ViewDat.vPos.y,0);
	ObjTree.RenderSprites(ViewDat);
	ObjWind.ActScene(&ObjTree,ActTime);

	glLoadIdentity();
	glRotatef(ViewDat.YDeg,1.0f,0.0f,0.0f);
	glRotatef(ViewDat.XDeg+180.0f,0.0f,1.0f,0.0f);
	glTranslatef(ViewDat.vPos.x,-ViewDat.vPos.y,-ViewDat.vPos.z);
	ObjTerrain.render();
	ObjSkyBox.Render();
	ObjFlash.Render();
	ObjTree.Render();
	ObjWaterfall.Render();
	glLoadIdentity();
	glRotatef(ViewDat.YDeg,1.0f,0.0f,0.0f);
	glRotatef(180.0f,0.0f,1.0f,0.0f);
	glTranslatef(0,-ViewDat.vPos.y,0);
	ObjWater.Render();
	if(DemoTime>200000) ObjRain.Render();
	if(DemoTime>100000) ObjFire.Render(ViewDat);
	SwapBuffers(OpenGL.hDC);
	char txt[10];
	itoa(FPS,txt,10);
	TextOut(OpenGL.hDC,0,0,txt,strlen(txt));
	ActFrame++;
	return TRUE;
}

void ActScene(DWORD time)
{
	float speed = time/50.0f;
	DemoTime+=time;
	if(KDown)
	{
		ViewDat.vPos.z-=(float)cos(ViewDat.XDeg*PI/180.0f)*speed;
		ViewDat.vPos.x-=(float)sin(ViewDat.XDeg*PI/180.0f)*speed;
	}
	if(KUp)
	{
		ViewDat.vPos.z+=(float)cos(ViewDat.XDeg*PI/180.0f)*speed;
		ViewDat.vPos.x+=(float)sin(ViewDat.XDeg*PI/180.0f)*speed;
	}
	if(KLeft)
	{
		ViewDat.vPos.z+=(float)cos((ViewDat.XDeg-90)*PI/180.0f)*speed;
		ViewDat.vPos.x+=(float)sin((ViewDat.XDeg-90)*PI/180.0f)*speed;
	}
	if(KRight)
	{
		ViewDat.vPos.z+=(float)cos((ViewDat.XDeg+90)*PI/180.0f)*speed;
		ViewDat.vPos.x+=(float)sin((ViewDat.XDeg+90)*PI/180.0f)*speed;
	}
	if(!bInter && DemoTime>7000 && DemoTime<50000 && ViewDat.XDeg<-25.0f) ViewDat.XDeg+=time/100.0f;
	if(!bInter && (ViewDat.XDeg>=-25.0f || DemoTime>50000) && ViewDat.vPos.x>-90.0f)
	{
		ViewDat.vPos.z+=(float)cos(ViewDat.XDeg*PI/180.0f)*time/250.0f;
		ViewDat.vPos.x+=(float)sin(ViewDat.XDeg*PI/180.0f)*time/250.0f;
	}
	if(!bInter && DemoTime>30000 && ObjSkyBox.alpha>0.0f)
	{
		ObjSkyBox.alpha-=(float)time/20000.0f;
		ObjWind.ampl+=(float)time/800000.0f;
		ObjWind.speed+=(float)time/20000.0f;
	}
	if(rand()%10==0 && ObjSkyBox.alpha<=0.0f)
	{
		float x = (float)(rand()%1000)-500.0f;
		float z = (float)(rand()%1000)-500.0f;
		ObjFlash.StartFlash(GLVECTOR(x,800,z),GLVECTOR(x,-2,z));
		ObjSkyBox.light = 1;
	}
	else
	{
		ObjFlash.StartFlash(GLVECTOR(2000,0,0),GLVECTOR(2000,0,0));
		ObjSkyBox.light = 0;
	}
	if(!bInter && ViewDat.vPos.z>-200.0f && ViewDat.XDeg>-55.0f) ViewDat.XDeg-=(float)time/1000.0f;
	if(!bInter && DemoTime>200000 && ObjRain.power<=250.0f) ObjRain.power+=(float)time/100.0f;
	if(!bInter && DemoTime>210000 && ObjFire.power>12.0f) ObjFire.power-=time/40.0f;
	ObjWater.ActScene(time,ViewDat);
	ObjWaterfall.ActScene(time);
	if(DemoTime>100000) ObjFire.ActScene(time);
	if(DemoTime>200000) ObjRain.ActRain(time);
	if(!bInter && DemoTime>240000) exit(0);
}