// GLSys.cpp: Implementierung der Klasse GLSys.

#include "GLSys.h"

GLSys::GLSys()
{
	hRC = NULL;
	hDC = NULL;
}

GLSys::~GLSys()
{
	ShutDown();
}


HRESULT GLSys::InitOpenGLTexture(DWORD Width,DWORD Height)
{
/*	HDC dc = wglGetCurrentDC();
	GLuint PixelFormat;
	static	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),	// Size Of This Pixel Format Descriptor
		1,								// Version Number
		WGL_DRAW_TO_PBUFFER_ARB |			// Format Must Support Bitmap
		PFD_SUPPORT_OPENGL |			// Format Must Support OpenGL
		WGL_BIND_TO_TEXTURE_RGB_ARB|
		PFD_TYPE_RGBA,					// Request An RGBA Format
		16,								// Select Our Color Depth
		0,0,0,0,0,0,					// Color Bits Ignored
		0,								// No Alpha Buffer
		0,								// Shift Bit Ignored
		0,								// No Accumulation Buffer
		0,0,0,0,						// Accumulation Bits Ignored
		16,								// 16Bit Z-Buffer (Depth Buffer)
		0,								// No Stencil Buffer
		0,								// No Auxiliary Buffer
		PFD_MAIN_PLANE,					// Main Drawing Layer
		0,								// Reserved
		0,0,0							// Layer Masks Ignored
	};
	if(!(PixelFormat=ChoosePixelFormat(dc,&pfd))) return FALSE;	//no suitable Pixel Format
	int attr[7];
	attr[0] = WGL_TEXTURE_FORMAT_ARB;
	attr[1] = WGL_TEXTURE_RGB_ARB;
	attr[2] = WGL_TEXTURE_TARGET_ARB;
	attr[3] = WGL_TEXTURE_2D_ARB;
	attr[4] = WGL_PBUFFER_LARGEST_ARB;
	attr[5] = 1;
	attr[6] = 0;
	hBuf = wglCreatePbufferARB(dc,PixelFormat,Width,Height,attr);
	hDC = wglGetPbufferDCARB(hBuf);
	hRC = wglCreateContext(hDC);
	if(!wglMakeCurrent(hDC,hRC)) return FALSE;						//context aktivieren
//	glViewport(0,0,Width,Height);

	//Render Settings
	glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	GLfloat LightAmbient[]= { 0.5f, 0.5f, 0.5f, 1.0f }; 
	GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };
	GLfloat LightPosition[]= { 0.0f, 0.0f, -2.0f, 1.0f };
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE,LightDiffuse);	
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);
	glEnable(GL_LIGHT1);							// Enable Light One
	glEnable(GL_LIGHTING);*/
	return TRUE;								// Success
}

HRESULT GLSys::InitOpenGLWindow(HWND hWnd)
{
	GLuint PixelFormat;
	RECT WindowRect;
	GetClientRect(hWnd,&WindowRect);
	static	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),	// Size Of This Pixel Format Descriptor
		1,								// Version Number
		PFD_DRAW_TO_WINDOW |			// Format Must Support Window
		PFD_SUPPORT_OPENGL |			// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,				// Must Support Double Buffering
		PFD_TYPE_RGBA,					// Request An RGBA Format
		32,								// Select Our Color Depth
		0,0,0,0,0,0,					// Color Bits Ignored
		0,								// No Alpha Buffer
		0,								// Shift Bit Ignored
		0,								// No Accumulation Buffer
		0,0,0,0,						// Accumulation Bits Ignored
		16,								// 16Bit Z-Buffer (Depth Buffer)
		0,								// No Stencil Buffer
		0,								// No Auxiliary Buffer
		PFD_MAIN_PLANE,					// Main Drawing Layer
		0,								// Reserved
		0,0,0							// Layer Masks Ignored
	};
	if(!(hDC=GetDC(hWnd))) return FALSE;								//no DC
	if(!(PixelFormat=ChoosePixelFormat(hDC,&pfd))) return FALSE;	//no suitable Pixel Format
	if(!SetPixelFormat(hDC,PixelFormat,&pfd)) return FALSE;			//impossible to set pf
	if(!(hRC=wglCreateContext(hDC))) return FALSE;					//not able to get Context
	if(!wglMakeCurrent(hDC,hRC)) return FALSE;						//context aktivieren
	ShowWindow(hWnd,SW_SHOW);
	SetForegroundWindow(hWnd);
	SetFocus(hWnd);
	glViewport(0,0,WindowRect.right,WindowRect.bottom);

	//Render Settings
	glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
/*	GLfloat LightAmbient[]= { 0.5f, 0.5f, 0.5f, 1.0f }; 
	GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };
	GLfloat LightPosition[]= { 0.0f, 0.0f, -2.0f, 1.0f };
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE,LightDiffuse);	
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);
	glEnable(GL_LIGHT1);							// Enable Light One*/
	glEnable(GL_LIGHTING);
	return TRUE;								// Success
}

HRESULT GLSys::InitOpenGLFullscreen(HINSTANCE hInstance,HWND *hWnd,WNDCLASS *dwExStyle,char *classname,char *title,DWORD Width,DWORD Height,DWORD BitDepth)
{
	RECT WindowRect;
	WindowRect.left=0;
	WindowRect.right=(long)Width;
	WindowRect.top=(long)0;
	WindowRect.bottom=(long)Height;
	DEVMODE dmScreenSettings;
	memset(&dmScreenSettings,0,sizeof(dmScreenSettings));
	dmScreenSettings.dmSize=sizeof(dmScreenSettings);
	dmScreenSettings.dmPelsWidth	= Width;
	dmScreenSettings.dmPelsHeight	= Height;
	dmScreenSettings.dmBitsPerPel	= BitDepth;
	dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;
	if(ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL) return FALSE;
	AdjustWindowRectEx(&WindowRect,WS_POPUP,FALSE,WS_EX_APPWINDOW);
	*hWnd=CreateWindow(classname,title,WS_POPUP,0,0,WindowRect.right-WindowRect.left,WindowRect.bottom-WindowRect.top,NULL,NULL,hInstance,NULL);
	GLuint PixelFormat;
	static	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),	// Size Of This Pixel Format Descriptor
		1,								// Version Number
		PFD_DRAW_TO_WINDOW |			// Format Must Support Window
		PFD_SUPPORT_OPENGL |			// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,				// Must Support Double Buffering
		PFD_TYPE_RGBA,					// Request An RGBA Format
		BitDepth,								// Select Our Color Depth
		0,0,0,0,0,0,					// Color Bits Ignored
		0,								// No Alpha Buffer
		0,								// Shift Bit Ignored
		0,								// No Accumulation Buffer
		0,0,0,0,						// Accumulation Bits Ignored
		32,								// 16Bit Z-Buffer (Depth Buffer)
		0,								// No Stencil Buffer
		0,								// No Auxiliary Buffer
		PFD_MAIN_PLANE,					// Main Drawing Layer
		0,								// Reserved
		0,0,0							// Layer Masks Ignored
	};
	if(!(hDC=GetDC(*hWnd))) return FALSE;								//no DC
	if(!(PixelFormat=ChoosePixelFormat(hDC,&pfd))) return FALSE;	//no suitable Pixel Format
	if(!SetPixelFormat(hDC,PixelFormat,&pfd)) return FALSE;			//impossible to set pf
	if(!(hRC=wglCreateContext(hDC))) return FALSE;					//not able to get Context
	if(!wglMakeCurrent(hDC,hRC)) return FALSE;						//context aktivieren
	ShowWindow(*hWnd,SW_SHOW);
	SetForegroundWindow(*hWnd);
	SetFocus(*hWnd);
	glViewport(0,0,WindowRect.right,WindowRect.bottom);
	
	//Render Setting	
	glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
	GLfloat LightAmbient[]= { 0.5f, 0.5f, 0.5f, 1.0f }; 
	GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };
	GLfloat LightPosition[]= { 0.0f, 0.0f, -2.0f, 1.0f };
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE,LightDiffuse);	
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);
	glEnable(GL_LIGHT1);							// Enable Light One
	glEnable(GL_LIGHTING);
	glCullFace(GL_FRONT);
	glEnable(GL_CULL_FACE);
	return TRUE;
}

HRESULT GLSys::SetProjection(float fFormat,float fFOV,float fNearPlane,float fFarPlane)
{
	wglMakeCurrent(hDC,hRC);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(fFOV,fFormat,fNearPlane,fFarPlane);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();	
	return TRUE;
}

void GLSys::Screenshot(char *name)
{
	int size[4];
	glGetIntegerv(GL_VIEWPORT,size);
	LPBYTE pixels = new BYTE[(size[2]-size[0])*(size[3]-size[1])*3];
	glReadPixels(size[0],size[1],size[2],size[3],GL_RGB,GL_UNSIGNED_BYTE,pixels);
	BITMAPFILEHEADER	bfh;
	BITMAPINFOHEADER	bih;
	ZeroMemory(&bfh,sizeof(bfh));
	ZeroMemory(&bih,sizeof(bih));
	bfh.bfType = MAKEWORD('B','M');
	bfh.bfSize = sizeof(BITMAPFILEHEADER)+
				sizeof(BITMAPINFOHEADER)+
				(size[2]-size[0])*(size[3]-size[1])*3;
	bfh.bfOffBits = sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);
	bih.biSize = sizeof(BITMAPINFOHEADER);
	bih.biWidth = size[2]-size[0];
	bih.biHeight = size[3]-size[1];
	bih.biPlanes = 1;
	bih.biBitCount = 24;
	bih.biCompression = BI_RGB;
	DWORD				dw;
	HANDLE hFile = CreateFile(name,GENERIC_WRITE,0,0,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,0);
	WriteFile(hFile,&bfh,sizeof(bfh),&dw,0);
	WriteFile(hFile,&bih,sizeof(bih),&dw,0);
	for(DWORD d=0;d<bih.biWidth*bih.biHeight;d++)
	{
		BYTE b = pixels[d*3];
		pixels[d*3] = pixels[d*3+2];
		pixels[d*3+2] = b;
	}
	WriteFile(hFile,pixels,bih.biWidth*bih.biHeight*3,&dw,0);
	CloseHandle(hFile);
	delete pixels;
}

HRESULT GLSys::ShutDown(void)
{
	wglMakeCurrent(hDC,hRC);
	ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
	ShowCursor(TRUE);								// Show Mouse Pointer
	wglMakeCurrent(NULL,NULL);
	wglDeleteContext(hRC);
	DeleteDC(hDC);
	hDC = NULL;
	hRC = NULL;
	return TRUE;
}

bool GLSys::CreateTextureAlpha(GLuint *texture,char *strName,char *strNameAlpha,bool linear,bool mipmap)
{
	wglMakeCurrent(hDC,hRC);
	BITMAPFILEHEADER	bfh;
	BITMAPINFOHEADER	bih;
	DWORD				dw;
	HANDLE hFile = CreateFile(strName,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(hFile,&bfh,sizeof(bfh),&dw,0);
	ReadFile(hFile,&bih,sizeof(bih),&dw,0);
	LPBYTE datatex = new BYTE[bih.biWidth*bih.biHeight*3];
	ReadFile(hFile,datatex,bih.biWidth*bih.biHeight*3,&dw,0);
	CloseHandle(hFile);
	BITMAPFILEHEADER	bfhalpha;
	BITMAPINFOHEADER	bihalpha;
	hFile = CreateFile(strNameAlpha,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(hFile,&bfhalpha,sizeof(bfhalpha),&dw,0);
	ReadFile(hFile,&bihalpha,sizeof(bihalpha),&dw,0);
	LPBYTE dataalpha = new BYTE[bihalpha.biWidth*bihalpha.biHeight+1024];
	ReadFile(hFile,dataalpha,bihalpha.biWidth*bihalpha.biHeight+1024,&dw,0);
	CloseHandle(hFile);
	LPBYTE data = new BYTE[bih.biHeight*bih.biWidth*4];
	if(bih.biWidth!=bihalpha.biWidth) return FALSE;
	if(bih.biHeight!=bihalpha.biHeight) return FALSE;
	for(DWORD d=0;d<bih.biWidth*bih.biHeight;d++)
	{
		data[d*4] = datatex[d*3+2];
		data[d*4+1] = datatex[d*3+1];
		data[d*4+2] = datatex[d*3];
		data[d*4+3] = dataalpha[d+1024];
	}
	delete datatex;
	delete dataalpha;
	glGenTextures(1,texture);
	glBindTexture(GL_TEXTURE_2D,*texture);
	if(mipmap)
	{
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_NEAREST);
		gluBuild2DMipmaps(GL_TEXTURE_2D,4,bih.biWidth,bih.biHeight,GL_RGBA,GL_UNSIGNED_BYTE,data);
	}
	else
	{
		if(linear)
		{
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		}
		else
		{
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		}
		glTexImage2D(GL_TEXTURE_2D,0,4,bih.biWidth,bih.biHeight,0,GL_RGBA,GL_UNSIGNED_BYTE,data);
	}
	delete data;
	return TRUE;
}

void GLSys::CreateEmptyTexture(GLuint *texture,BYTE colors,GLenum format,bool linear,DWORD Width,DWORD Height)
{
	wglMakeCurrent(hDC,hRC);
	glGenTextures(1,texture);
	glBindTexture(GL_TEXTURE_2D,*texture);
	if(linear)
	{
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	}
	else
	{
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	}
	glTexImage2D(GL_TEXTURE_2D,0,colors,Width,Height,0,format,GL_UNSIGNED_BYTE,0);
}

void GLSys::CreateTexture(GLuint *texture,char *strName,BYTE colors,GLenum format,bool linear,bool mipmap)
{
	wglMakeCurrent(hDC,hRC);
	AUX_RGBImageRec *TextureImage[1];
	ZeroMemory(TextureImage,sizeof(void*));
	TextureImage[0]=auxDIBImageLoad(strName);
	glGenTextures(1,texture);
	glBindTexture(GL_TEXTURE_2D,*texture);
	if(mipmap)
	{
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_NEAREST);
		gluBuild2DMipmaps(GL_TEXTURE_2D,colors,TextureImage[0]->sizeX,TextureImage[0]->sizeY,format,GL_UNSIGNED_BYTE,TextureImage[0]->data);
	}
	else
	{
		if(linear)
		{
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		}
		else
		{
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		}
		glTexImage2D(GL_TEXTURE_2D,0,colors,TextureImage[0]->sizeX,TextureImage[0]->sizeY,0,format,GL_UNSIGNED_BYTE,TextureImage[0]->data);
	}
}

bool GLSys::LoadTGA(GLuint *tex,char* filename)
{
/*	GLubyte		TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};
	GLubyte		TGAcompare[12];
	GLubyte		header[6];
	GLuint		bytesPerPixel;
	GLuint		imageSize;
	GLuint		temp;
	GLuint		type=GL_RGBA;
	FILE* pFile = fopen(filename, "rb");
	if(pFile==NULL													   ||
	   fread(TGAcompare,1,sizeof(TGAcompare),pFile)!=sizeof(TGAcompare) ||
	   memcmp(TGAheader,TGAcompare,sizeof(TGAheader))!=0			   ||
	   fread(header,1,sizeof(header),pFile)!=sizeof(header))
		{
			return false;
		}

	width = header[1] * 256 + header[0];
	height= header[3] * 256 + header[2];
    
 	if(width	<=0	||
	   height<=0	||
		(header[4]!=24 && header[4]!=32))
		{
			fclose(pFile);
			return false;
		}

	bpp	 = header[4];
	bytesPerPixel= bpp/8;
	imageSize	 = width*height*bytesPerPixel;

	data= new GLubyte [imageSize];
	if(data==NULL ||	
	   fread(data, 1, imageSize, pFile)!=imageSize)
		{
		if(data!=NULL)
			free(data);	
		
		
		fclose(pFile);
		return false;
		}

	for(GLuint i=0; i<int(imageSize); i+=bytesPerPixel)
		{
		temp	 =data[i];						
		data[i]	 = data[i + 2];
		data[i+2]= temp;
		}

	fclose (pFile);

	
	glGenTextures(1,tex);

	glBindTexture(GL_TEXTURE_2D,*tex);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	
	if(bpp==24)									
		type=GL_RGB;							
	glTexImage2D(GL_TEXTURE_2D, 0, type, width, height, 0, type, GL_UNSIGNED_BYTE, data);*/
	return true;
}

GLVECTOR GLSys::GetPointOnY(CAMERA ViewDat,int wndx,int wndy,int x,int y,float pointy)
{
	GLVECTOR vT,vSrc,vDest;
	if(ViewDat.YDeg==0.0f && ViewDat.FOV==60.0f)
	{
		float Faktor = (wndx+wndy)*0.37f;
		vT.z = ((ViewDat.vPos.y-pointy)*Faktor)/((float)y-(float)wndy/2.0f);
		vT.x = (((float)x-(float)wndx/2.0f)*vT.z)/Faktor;
		vT.y = pointy;
		vDest.x = (float)cos(ViewDat.XDeg*PI/180.0f)*vT.x+(float)sin(ViewDat.XDeg*PI/180.0f)*vT.z+ViewDat.vPos.x;
		vDest.z = -(float)sin(ViewDat.XDeg*PI/180.0f)*vT.x+(float)cos(ViewDat.XDeg*PI/180.0f)*vT.z+ViewDat.vPos.z;
		vDest.y = vT.y;
	}
	else if(ViewDat.YDeg==-90.0f && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.y/17800000.0f;
		vDest.x = (x-wndx/2)*base+ViewDat.vPos.x;
		vDest.z = (wndy/2-y)*base+ViewDat.vPos.z;
		vDest.y = pointy;
	}
	else if(ViewDat.YDeg==0.0f && (ViewDat.XDeg==0.0f || ViewDat.XDeg==180.0f) && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.z/17800000.0f;
		vDest.x = -(x-wndx/2)*base+ViewDat.vPos.x;
		vDest.y = pointy;
		vDest.z = 0.0f;
	}
	else if(ViewDat.YDeg==0.0f && (ViewDat.XDeg==90.0f || ViewDat.XDeg==-90.0f) && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.x/17800000.0f;
		vDest.x = 0.0f;
		vDest.y = pointy;
		vDest.z = (x-wndx/2)*base+ViewDat.vPos.z;
	}
	return vDest;
}

GLVECTOR GLSys::GetSourcePointOnY(CAMERA ViewDat,int wndx,int wndy,int x,int y,float pointy)
{
	GLVECTOR vT;
	float Faktor = (wndx+wndy)*0.37f;
	if(ViewDat.FOV==0.001f) Faktor = (wndx+wndy)*0.2f;
	vT.z = ((ViewDat.vPos.y-pointy)*Faktor)/((float)y-(float)wndy/2.0f);
	vT.x = (((float)x-(float)wndx/2.0f)*vT.z)/Faktor;
	vT.y = pointy;
	return vT;
}

GLVECTOR GLSys::GetPointOnCamera(CAMERA ViewDat,int wndx,int wndy,int x,int y)
{
	GLVECTOR vTemp,vDest;
	if(ViewDat.YDeg==0.0f && ViewDat.FOV==60.0f)
	{
		float Faktor = (wndx+wndy)*0.37f;
		vTemp.z = 1.0f;
		vTemp.y = vTemp.z*((float)wndy/2.0f-(float)y)/Faktor;
		vTemp.x = (((float)x-(float)wndx/2.0f)*vTemp.z)/Faktor;
		vDest.x = vTemp.x*(float)cos(ViewDat.XDeg*PI/180.0f)+vTemp.z*(float)sin(ViewDat.XDeg*PI/180.0f);
		vDest.z = -vTemp.x*(float)sin(ViewDat.XDeg*PI/180.0f)+vTemp.z*(float)cos(ViewDat.XDeg*PI/180.0f);
		vDest.y = vTemp.y;
	}
	else if(ViewDat.YDeg==-90.0f && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.y/17800000.0f;
		vDest.x = (x-wndx/2)*base+ViewDat.vPos.x;
		vDest.z = (wndy/2-y)*base+ViewDat.vPos.z;
		vDest.y = 0.0f;
	}
	else if(ViewDat.YDeg==0.0f && (ViewDat.XDeg==0.0f || ViewDat.XDeg==180.0f) && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.z/17800000.0f;
		vDest.x = -(x-wndx/2)*base+ViewDat.vPos.x;
		vDest.y = (wndy/2-y)*(float)fabs(base)+ViewDat.vPos.y;
		vDest.z = 0.0f;
	}
	else if(ViewDat.YDeg==0.0f && (ViewDat.XDeg==90.0f || ViewDat.XDeg==-90.0f) && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.x/17800000.0f;
		vDest.x = 0.0f;
		vDest.y = (wndy/2-y)*(float)fabs(base)+ViewDat.vPos.y;
		vDest.z = (x-wndx/2)*base+ViewDat.vPos.z;
	}
	return vDest;
}

GLVECTOR GLSys::GetPointOnXZ(CAMERA ViewDat,int wndx,int wndy,int y,float pointx,float pointz)
{
	GLVECTOR vDest,vT;
	if(ViewDat.YDeg==0.0f && ViewDat.FOV==60.0f)
	{
		float Faktor = (wndx+wndy)*0.37f;
		vT.z = -(pointx-ViewDat.vPos.x)*(float)sin(-ViewDat.XDeg*PI/180.0f)+(pointz-ViewDat.vPos.z)*(float)cos(-ViewDat.XDeg*PI/180.0f);
		vDest.y = vT.z*((float)wndy/2.0f-(float)y)/Faktor+ViewDat.vPos.y;
		vDest.x = pointx;
		vDest.z = pointz;
	}
	else if(ViewDat.YDeg==0.0f && (ViewDat.XDeg==0.0f || ViewDat.XDeg==180.0f) && ViewDat.FOV==0.001f)
	{
		float base = ViewDat.vPos.z/17800000.0f;
		vDest.x = pointx;
		vDest.y = -(y-wndy/2)*(float)fabs(base)+ViewDat.vPos.y;
		vDest.z = pointz;
	}
	else if(ViewDat.YDeg==0.0f && (ViewDat.XDeg==90.0f || ViewDat.XDeg==-90.0f) && ViewDat.FOV==0.001f)
	{
		float base;
		if(ViewDat.XDeg==90.0f) base = ViewDat.vPos.x/17800000.0f;
		else base = -ViewDat.vPos.x/17800000.0f;
		vDest.x = pointx;
		vDest.y = (y-wndy/2)*base+ViewDat.vPos.y;
		vDest.z = pointz;
	}
	return vDest;
}

GLVECTOR::GLVECTOR(float a_x,float a_y,float a_z)
{
	x=a_x;
	y=a_y;
	z=a_z;
}

GLVECTOR::GLVECTOR()
{
	x=0.0f;
	y=0.0f;
	z=0.0f;
}

void GLVECTOR::operator +=(GLVECTOR add)
{
	x+=add.x;
	y+=add.y;
	z+=add.z;
}

void GLVECTOR::operator -=(GLVECTOR sub)
{
	x-=sub.x;
	y-=sub.y;
	z-=sub.z;
}

bool GLVECTOR::operator==(GLVECTOR v1)
{
	if(x==v1.x)
		if(y==v1.y)
			if(z==v1.z)
				return true;
	return false;
}

GLVECTOR GLVECTOR::operator +(GLVECTOR add)
{
	GLVECTOR res;
	res.x=x+add.x;
	res.y=y+add.y;
	res.z=z+add.z;
	return res;
}

GLVECTOR GLVECTOR::operator -(GLVECTOR sub)
{
	GLVECTOR res;
	res.x=x-sub.x;
	res.y=y-sub.y;
	res.z=z-sub.z;
	return res;
}

GLVECTOR GLVECTOR::operator *(float scale)
{
	GLVECTOR res;
	res.x=x*scale;
	res.y=y*scale;
	res.z=z*scale;
	return res;
}

GLVECTOR GLVECTOR::operator /(float scale)
{
	GLVECTOR res;
	res.x=x/scale;
	res.y=y/scale;
	res.z=z/scale;
	return res;
}

GLVERTEX::GLVERTEX()
{
	x=y=z=nx=ny=nz=tu=tv=0.0f;
}

GLVERTEX::GLVERTEX(GLVECTOR a_point)
{
	x=a_point.x;
	y=a_point.y;
	z=a_point.z;
}

GLVERTEX::GLVERTEX(GLVECTOR a_point,GLVECTOR a_normal)
{
	x=a_point.x;
	y=a_point.y;
	z=a_point.z;
	nx=a_normal.x;
	ny=a_normal.y;
	nz=a_normal.z;
}

GLVERTEX::GLVERTEX(GLVECTOR a_point,GLVECTOR a_normal,float a_tu,float a_tv)
{ 
	x=a_point.x;
	y=a_point.y;
	z=a_point.z;
	nx=a_normal.x;
	ny=a_normal.y;
	nz=a_normal.z;
	tu=a_tu;
	tv=a_tv;
}

GLVECTOR VectorMatrixMultiply(GLVECTOR &src,GLMATRIX mat)
{
	GLVECTOR dest;
	dest.x = src.x*mat.m[1][1]+src.y*mat.m[1][2]+src.z*mat.m[1][3]+mat.m[1][4];
	dest.y = src.x*mat.m[2][1]+src.y*mat.m[2][2]+src.z*mat.m[2][3]+mat.m[2][4];
	dest.z = src.x*mat.m[3][1]+src.y*mat.m[3][2]+src.z*mat.m[3][3]+mat.m[3][4];
	return dest;
}

GLVERTEX VertexMatrixMultiply(GLVERTEX &src,GLMATRIX mat)
{
	GLVERTEX dest;
	dest.x = src.x*mat.m[1][1]+src.y*mat.m[1][2]+src.z*mat.m[1][3]+mat.m[1][4];
	dest.y = src.x*mat.m[2][1]+src.y*mat.m[2][2]+src.z*mat.m[2][3]+mat.m[2][4];
	dest.z = src.x*mat.m[3][1]+src.y*mat.m[3][2]+src.z*mat.m[3][3]+mat.m[3][4];
	dest.nx = src.nx*mat.m[1][1]+src.ny*mat.m[1][2]+src.nz*mat.m[1][3]+mat.m[1][4];
	dest.ny = src.nx*mat.m[2][1]+src.ny*mat.m[2][2]+src.nz*mat.m[2][3]+mat.m[2][4];
	dest.nz = src.nx*mat.m[3][1]+src.ny*mat.m[3][2]+src.nz*mat.m[3][3]+mat.m[3][4];
	dest.tu = src.tu;
	dest.tv = src.tv;
	return dest;
}

GLMATRIX MatrixMultiply(GLMATRIX& a,GLMATRIX& b)
{
	GLMATRIX q;
    FLOAT* pA = (FLOAT*)&a;
    FLOAT* pB = (FLOAT*)&b;
	float pM[16];
	ZeroMemory(pM,sizeof(pM));
    ZeroMemory(&q,sizeof(GLMATRIX));
    for(WORD i=0;i<4;i++ ) 
        for(WORD j=0;j<4;j++) 
            for(WORD k=0;k<4;k++) pM[i*4+j] += pA[4*k+j] * pB[4*i+k];
	memcpy(&q,pM,sizeof(GLMATRIX));
	return q;
}

HRESULT MatrixInvert(GLMATRIX& q,GLMATRIX& a)
{
    if(fabs(a.m[4][4]-1.0f)>0.001f) return E_INVALIDARG;
    if(fabs(a.m[1][4])>0.001f || fabs(a.m[2][4])>0.001f || fabs(a.m[3][4])>0.001f) return E_INVALIDARG;

    FLOAT fDetInv = 1.0f / ( a.m[1][1] * ( a.m[2][2] * a.m[3][3] - a.m[2][3] * a.m[3][2] ) -
                             a.m[1][2] * ( a.m[2][1] * a.m[3][3] - a.m[2][3] * a.m[3][1] ) +
                             a.m[1][3] * ( a.m[2][1] * a.m[3][2] - a.m[2][2] * a.m[3][1] ) );

    q.m[1][1] =  fDetInv * ( a.m[2][2] * a.m[3][3] - a.m[2][3] * a.m[3][2] );
    q.m[1][2] = -fDetInv * ( a.m[1][2] * a.m[3][3] - a.m[1][3] * a.m[3][2] );
    q.m[1][3] =  fDetInv * ( a.m[1][2] * a.m[2][3] - a.m[1][3] * a.m[2][2] );
    q.m[1][4] = 0.0f;

    q.m[2][1] = -fDetInv * ( a.m[2][1] * a.m[3][3] - a.m[2][3] * a.m[3][1] );
    q.m[2][2] =  fDetInv * ( a.m[1][1] * a.m[3][3] - a.m[1][3] * a.m[3][1] );
    q.m[2][3] = -fDetInv * ( a.m[1][1] * a.m[2][3] - a.m[1][3] * a.m[2][1] );
    q.m[2][4] = 0.0f;

    q.m[3][1] =  fDetInv * ( a.m[2][1] * a.m[3][2] - a.m[2][2] * a.m[3][1] );
    q.m[3][2] = -fDetInv * ( a.m[1][1] * a.m[3][2] - a.m[1][2] * a.m[3][1] );
    q.m[3][3] =  fDetInv * ( a.m[1][1] * a.m[2][2] - a.m[1][2] * a.m[2][1] );
    q.m[3][4] = 0.0f;

    q.m[4][1] = -( a.m[4][1] * q.m[1][1] + a.m[4][2] * q.m[2][1] + a.m[4][3] * q.m[3][1] );
    q.m[4][2] = -( a.m[4][1] * q.m[1][2] + a.m[4][2] * q.m[2][2] + a.m[4][3] * q.m[3][2] );
    q.m[4][3] = -( a.m[4][1] * q.m[1][3] + a.m[4][2] * q.m[2][3] + a.m[4][3] * q.m[3][3] );
    q.m[4][4] = 1.0f;

    return S_OK;
}

GLMATRIX CreateRotateMatrix(float x,float y,float z)
{
	GLMATRIX m;
	float sy = (float)sin(y*PI/180.0f);
	float sx = (float)sin(z*PI/180.0f);
	float sz = (float)sin(x*PI/180.0f);
	float cy = (float)cos(y*PI/180.0f);
	float cx = (float)cos(z*PI/180.0f);
	float cz = (float)cos(x*PI/180.0f);
	m.m[1][1] = cx*cy + -sx * -sz * -sy;
	m.m[1][2] = -sx*cz;
	m.m[1][3] = cx*sy + -sx * -sz * cy;
	m.m[1][4] = 0;
	m.m[2][1] = sx*cy + cx * -sz * -sy;
	m.m[2][2] = cx*cz;
	m.m[2][3] = sx*sy + cx*-sz*cy;
	m.m[2][4] = 0;
	m.m[3][1] = cz*-sy;
	m.m[3][2] = sz;
	m.m[3][3] = cz*cy;
	m.m[3][4] = 0;
	m.m[4][4] = 1.0f;
	return m;
}

BOOL IntersectTriangle(GLVECTOR orig,GLVECTOR dir,GLVECTOR vert0,GLVECTOR vert1,GLVECTOR vert2,FLOAT *t,FLOAT *u,FLOAT *v)
{
	GLVECTOR	edge1,edge2,tvec,pvec,qvec;
	FLOAT		det,inv_det;

	edge1 = vert1-vert0;				//Find Vectors for two Edges sharing ver0
	edge2 = vert2-vert0;
	pvec = CrossProduct(dir,edge2);		//Begin calculating determinant
	det = DotProduct(edge1,pvec);		//if determinant is near zero, ray lies in plane of triangle
	if(det>-0.0001f && det<0.0001f) return FALSE;
	inv_det = 1.0f/det;
	tvec = orig-vert0;					//Calculate distance from vert0 to ray origin
	*u = DotProduct(tvec,pvec)*inv_det;	//Calculate u parameter and test bound
	if(*u<0.0f || *u>1.0f) return FALSE;
	qvec = CrossProduct(tvec,edge1);	//Prepare to test v parameter
	*v = DotProduct(dir,qvec)*inv_det;	//Calculate v parameter and test bound
	if(*v<0.0f || *u+*v>1.0f) return FALSE;
	*t = DotProduct(edge2,qvec)*inv_det;//Calculate t, ray intersects triangle
	return TRUE;
}

BOOL TestIntersection(GLVECTOR orig,GLVECTOR dir,GLVECTOR vert0,GLVECTOR vert1,GLVECTOR vert2)
{
	GLVECTOR	edge1,edge2,tvec,pvec,qvec;
	FLOAT		det,inv_det,v,u;

	edge1 = vert1-vert0;				//Find Vectors for two Edges sharing ver0
	edge2 = vert2-vert0;
	pvec = CrossProduct(dir,edge2);		//Begin calculating determinant
	det = DotProduct(edge1,pvec);		//if determinant is near zero, ray lies in plane of triangle
	if(det>-0.0001f && det<0.0001f) return FALSE;
	inv_det = 1.0f/det;
	tvec = orig-vert0;					//Calculate distance from vert0 to ray origin
	u = DotProduct(tvec,pvec)*inv_det;	//Calculate u parameter and test bound
	if(u<0.0f || u>1.0f) return FALSE;
	qvec = CrossProduct(tvec,edge1);	//Prepare to test v parameter
	v = DotProduct(dir,qvec)*inv_det;	//Calculate v parameter and test bound
	if(v<0.0f || u+v>1.0f) return FALSE;
	return TRUE;
}

GLVECTOR Round(GLVECTOR vSrc,float base)
{
	GLVECTOR vDest;
	double iOut;
	float temp = (float)modf(vSrc.x/base,&iOut);
	if(0.5f>fabs(temp)) temp = 0.0f;
	else
	{
		if(temp<0.0f) temp=-1.0f;
		else temp=1.0f;
	}
	vDest.x = ((float)iOut+temp)*base;
	temp = (float)modf(vSrc.y/base,&iOut);
	if(0.5f>fabs(temp)) temp = 0.0f;
	else
	{
		if(temp<0.0f) temp=-1.0f;
		else temp=1.0f;
	}
	vDest.y = ((float)iOut+temp)*base;
	temp = (float)modf(vSrc.z/base,&iOut);
	if(0.5f>fabs(temp)) temp = 0.0f;
	else
	{
		if(temp<0.0f) temp=-1.0f;
		else temp=1.0f;
	}
	vDest.z = ((float)iOut+temp)*base;
	return vDest;
}

float Magnitude(GLVECTOR v1)
{
	return(float)sqrt(v1.x*v1.x+v1.y*v1.y+v1.z*v1.z);
}

GLVECTOR Normalize(GLVECTOR vec)
{
	GLVECTOR vDest;
	float mag=Magnitude(vec);
	vDest = vec/mag;
	return vDest;
}

float DotProduct(GLVECTOR v1,GLVECTOR v2)
{
	return v1.x*v2.x + v1.y*v2.y + v1.z*v2.z;
}

double AngleBetweenVectors(GLVECTOR v1,GLVECTOR v2)
{
	float dotProduct=DotProduct(v1,v2);
	float vectorsMagnitude=Magnitude(v1)*Magnitude(v2);
	return acos(dotProduct/vectorsMagnitude);
}

GLVECTOR CrossProduct(GLVECTOR v1,GLVECTOR v2)
{
	GLVECTOR result;
	result.x=v1.y* v2.z - v1.z*v2.y;
	result.y=v1.z*v2.x - v1.x*v2.z;
	result.z=v1.x*v2.y - v1.y*v2.x;
	return result;
}

GLVECTOR ComputeNormal(GLVECTOR a,GLVECTOR b,GLVECTOR c)
{
	return Normalize(CrossProduct(c-a,b-a));
}

void SetIdentityMatrix(GLMATRIX& mat)
{
	mat.m[0][0]=1;
	mat.m[1][1]=1;
	mat.m[2][2]=1;
	mat.m[3][3]=1;
}

void MatrixMultiply( GLMATRIX& q, GLMATRIX& a, GLMATRIX& b )
{
    FLOAT* pA = (FLOAT*)&a;
    FLOAT* pB = (FLOAT*)&b;
    FLOAT  pM[16];
    ZeroMemory(pM,sizeof(GLMATRIX));
    for(WORD i=0;i<4;i++) 
        for(WORD j=0;j<4;j++) 
            for( WORD k=0;k<4;k++) 
                pM[4*i+j]+=pA[4*k+j]*pB[4*i+k];
    memcpy(&q,pM,sizeof(GLMATRIX));
}

void SetTranslateMatrix(GLMATRIX& mat,float tx,float ty,float tz)
{
	mat.m[0][0]=1;
	mat.m[1][1]=1;
	mat.m[2][2]=1;
	mat.m[3][3]=1;
	mat.m[3][0]=tx;
	mat.m[3][1]=ty;
	mat.m[3][2]=tz;
}

void SetScaleMatrix(GLMATRIX& mat,float sx,float sy,float sz)
{
	mat.m[0][0]=sx;
	mat.m[1][1]=sy;
	mat.m[2][2]=sz;
	mat.m[3][3]=1;
}

void SetRotateXMatrix(GLMATRIX& mat,float d_angle)
{
	mat.m[0][0]=1;
	mat.m[1][1]=(float)cos(d_angle);
	mat.m[1][2]=(float)sin(d_angle);
	mat.m[2][1]=-(float)sin(d_angle);
	mat.m[2][2]=(float)cos(d_angle);
	mat.m[3][3]=1;
}

void SetRotateYMatrix(GLMATRIX& mat,float d_angle)
{
	mat.m[0][0]=(float)cos(d_angle);
	mat.m[0][2]=-(float)sin(d_angle);
	mat.m[1][1]=1;
	mat.m[2][0]=(float)sin(d_angle);
	mat.m[2][2]=(float)cos(d_angle);
	mat.m[3][3]=1;
}

void SetRotateZMatrix(GLMATRIX& mat,float d_angle)
{
	mat.m[0][0]=(float)cos(d_angle);
	mat.m[0][1]=(float)sin(d_angle);
	mat.m[1][0]=-(float)sin(d_angle);
	mat.m[1][1]=(float)cos(d_angle);
	mat.m[2][2]=1;
	mat.m[3][3]=1;
}